<template>
  <div class="card" :id="id">
    <!--<div v-bind:class="status" class="d-none"></div>-->
    <div class="card-img-left">
      <!--TODO replace dummy pic with a no attribution picture-->
      <img v-if="thumbnail == null || thumbnail.length == 0" class="card-img" src="~static/img/placeholder.png" alt="Card image cap">
      <!--TODO benerin src -->
      <img v-else class="card-img" :src="'http://backend-coba.sikatan.net/image/' + thumbnail[0].filename" alt="Card image cap">
    </div>
    <div class="card-right">
      <div class="card-title" :title="title" @click="detail" :disableDetail="disableDetail">
        <h5>{{ title }}</h5>
      </div>
      <p class="price">Rp. {{ price }} /bulan</p>
      <div class="tags">
        <span class="status badge active-badge" v-if="isActive=='1'">active</span>
        <span class="status badge deleted-badge" v-if="isDeleted=='1'">deleted</span>
        <span class="status badge draft-badge" v-if="isDraft=='1'">draft</span>
      </div>
    </div>
    <div class="btn-container">
      <div class="form-check" v-if="checkbox == true">
        <input class="form-check-input" type="checkbox" :id="id" @change="clickFunct" :checked="isTicked">
      </div>
      <button type="button" class="close" v-if="dismiss == true" @click="clickFunct">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="edit-button" v-if="editable == true">
      <Button class="btn-sm" :onClick="editFn">EDIT</Button>
    </div>
  </div>
</template>

<script>
import Button from '../components/Button'

export default {
  props: {
    id : {
      type: Number,
      default: 0
    },
    thumbnail : {
      type: Array,
      default: function () { return [] }
    },
    title : {
      type: String,
      default: "Dummy"
    },
    price : {
      type: String,
      default: "0"
    },
    clickFunct : {
      type: Function,
      default: function () { return }
    },
    checkbox : {
      type: Boolean,
      default: false
    },
    isTicked : {
      type: Boolean,
      default: false
    },
    dismiss : {
      type: Boolean,
      default: false
    },
    editable : {
      type: Boolean,
      default: true
    }, 
    isActive : {
      type: String,
      default: "0"
    },
    isDeleted : {
      type: String,
      default: "0"
    },
    isDraft : {
      type: String,
      default: "0"
    },
    disableDetail : {
      type: Boolean,
      default: false
    }
  },
  components: {
    Button
  },
  methods: {
    editFn() {
      alert('TODO: bikin page/modal edit(?)')
    },
    detail() {
      if (this.disableDetail == false) {
        this.$store.dispatch('product/SET_PREVIOUS_PAGE', {prevPage: this.$route.fullPath})
        this.$router.replace({ 'path': '/product/' +  this.id})
      }
    }
  }
};

</script>

<style>
  .card {
    border: none;
    width: 30rem;
    height: 10rem  !important;
    margin-top: 10px;
    margin-left: 20px;
    -webkit-transition: box-shadow 2s; /* Safari */
    transition: box-shadow 0.25s;
  }

  .card:hover {
    box-shadow: 0px 1px 10px rgba(0, 0, 0, 0.25);
  }

  .card-img-left {
    width: 10rem;
    height: 10rem;
    display: flex;
    flex-flow: column;
    justify-content: center;
    align-items: center;
    position: absolute;
    margin-left: 10px;
  }

  .card-img {
    width: 100%;
  }
  img:before {
    width: 100%;
    background-image: url('~static/img/placeholder.png');
  }

  .card-right {
    padding-left: 40%;
    text-align: left;
    display: flex;
    flex-flow: column;
    position: absolute;
    top: 25%;
  }

  .card p {
    font-size: 12px;
  }

  .card-title {
    margin-bottom: 0.15rem;
    font-family: "Quicksand", "Source Sans Pro", -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif; /* 1 */
    display: block;
    width: 15rem;
    height: 1.5rem;
    overflow: hidden;
    cursor: pointer;
  }

  .price {
    color: var(--green);
  }

  .deleted-badge {
    background-color: var(--grey);
    font-family: 'Nunito', sans-serif;
    font-weight: 100;
    color: white
  }

  .active-badge {
    background-color: var(--green);
    font-family: 'Nunito', sans-serif;
    font-weight: 100;
    color: white
  }

  .draft-badge {
    background-color: var(--orange);
    font-family: 'Nunito', sans-serif;
    font-weight: 100;
    color: white
  }

  .card-title {
    text-overflow: ellipsis-word;
  }

  .btn-container {
    position: absolute;
    top: 1rem;
    right: 1rem;
  }

  .edit-button {
    position: absolute;
    bottom: 1rem;
    right: 1rem;
  }

  .tags {
    margin-top: -1rem;
  }
</style>
